### Method

# Gio DataInputStream read_until

deprecated: 2.56

#### Declaration

    char*
    g_data_input_stream_read_until (
      GDataInputStream* stream,
      const gchar* stop_chars,
      gsize* length,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Reads a string from the data input stream, up to the first occurrence of any of the stop characters.

Note that, in contrast to g_data_input_stream_read_until_async(), this function consumes the stop character that it finds.

Don’t use this function in new code. Its functionality is inconsistent with g_data_input_stream_read_until_async(). Both functions will be marked as deprecated in a future release. Use `g_data_input_stream_read_upto()` instead, but note that that function does not consume the stop character.

Deprecated since: 2.56

Use `g_data_input_stream_read_upto()` instead, which has more consistent behaviour regarding the stop character.

#### Parameters

`stop_chars`

  Type: `const gchar*`

  Characters to terminate the read.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`length`

  Type: `gsize*`

  A #gsize to get the length of the data read in.

  The argument will be set by the function.
  The argument can be `NULL`.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `char*`

A string with the data that was read before encountering any of the stop characters. Set `length` to a #gsize to get the length of the string. This function will return `NULL` on an error.

The caller of the method takes ownership of the data, and is responsible for freeing it.
The value is a NUL terminated UTF-8 string.